package de.unima.ki.pi2.ptest.aufgabe1.test;

import static junitx.framework.ArrayAssert.assertEquals;
import static org.junit.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

import de.unima.ki.pi2.ptest.aufgabe1.api.LogicBW;
import de.unima.ki.pi2.ptest.aufgabe1.impl.LogicBWImpl;

public class LogicBWTest {
	
	
	private LogicBW logic;
	private boolean[] b0 = {};
	private boolean[] b1 = {true, false, true};
	private boolean[] b2 = {false, true, false};
	private boolean[] b3 = {true, true, true};
	private boolean[] b4 = {false, false, false};
	private boolean[] b5 = {true, false, true,  false, true, false, true};
	private boolean[] b6 = {true, false, false, true,  true, false, false};
	private boolean[] b7 = {true, false, false, false, true, false, false};
	private boolean[] b8 = {true, false, true,  true,  true, false, true};
	
	@Before
	public void init(){ 
		this.logic = new LogicBWImpl();
	}
	
	// testing and

	@Test
	public void testAnd1() {
		assertEquals(b4, this.logic.computeAnd(b1, b2));
	}
	
	@Test
	public void testAnd2() {
		assertEquals(b4, this.logic.computeAnd(b3, b4));
	}
	
	@Test
	public void testAnd3() {
		assertEquals(b3, this.logic.computeAnd(b3, b3));
	}
	
	@Test
	public void testAnd4() {
		assertEquals(b7, this.logic.computeAnd(b5, b6));
	}
	
	@Test
	public void testAnd5() {
		assertEquals(null, this.logic.computeAnd(b4, b5));
	}
	
	@Test
	public void testAnd6() {
		assertEquals(null, this.logic.computeAnd(b0, b0));
	}
	
	/*
	@Test
	public void testAndNEW() {
		boolean[] x = {true, true, true, false, true, false, true};
		boolean[] y = {false, false, false, true, false, true, true};
		boolean[] result = {false, false, false, false, false, false, true};
		assertEquals(result, this.logic.computeAnd(x,y));
	}
	*/

	// testing or

	@Test
	public void testOr1() {
		assertEquals(b3, this.logic.computeOr(b1, b2));
	}
	
	@Test
	public void testOr2() {
		assertEquals(b3, this.logic.computeOr(b3, b4));
	}
	
	@Test
	public void testOr3() {
		assertEquals(b3, this.logic.computeOr(b3, b3));
	}
	
	@Test
	public void testOr4() {
		assertEquals(b8, this.logic.computeOr(b5, b6));
	}
	
	@Test
	public void testOr5() {
		assertEquals(null, this.logic.computeOr(b4, b5));
	}
	
	@Test
	public void testOr6() {
		assertEquals(null, this.logic.computeOr(b0, b0));
	}
	
	/*
	@Test
	public void testOrNEW() {
		boolean[] x  =     {true, true, true, false, true, false, false};
		boolean[] y =      {false, false, false, true, false, true, false};
		boolean[] result = {true, true, true, true, true, true, false};
		assertEquals(result, this.logic.computeOr(x,y));
	}
	*/
	
	// testing not
	
	@Test
	public void testNot1() {
		assertEquals(b2, this.logic.computeNot(b1));
		assertEquals(b1, this.logic.computeNot(b2));
	}
	
	@Test
	public void testNot2() {
		assertEquals(null, this.logic.computeNot(b0));
	}

	/*
	@Test
	public void testNotNEW() {
		boolean[] x  = {true, true, true, false, true, false, false};
		boolean[] result = {false, false, false, true, false, true, true};
		assertEquals(result, this.logic.computeNot(x));
	}
	*/

}
