package de.unima.ki.pi2.ptest.aufgabe3.test;

import static junitx.framework.ArrayAssert.assertEquals;
import static junit.framework.Assert.assertEquals;

import org.junit.Before;
import org.junit.Test;

import de.unima.ki.pi2.ptest.aufgabe3.api.Adder;
import de.unima.ki.pi2.ptest.aufgabe3.impl.AdderImpl;

public class AdderTest {
	
	private Adder adder;
	
	private boolean[] n1_4;
	private boolean[] n2_4;
	private boolean[] n3_4;
	private boolean[] n3_6;
	private boolean[] n7_3;
	private boolean[] n0_3;
	private boolean[] n6_3;
	private boolean[] n17_5;
	private boolean[] n15_5;
	private boolean[] n16_5;
	
	@Before
	public void init(){ 
		this.adder = new AdderImpl();
		this.n1_4 = new boolean[]{true, false, false, false};
		this.n2_4 = new boolean[]{false, true, false, false};
		this.n3_4 = new boolean[]{true, true, false, false};
		this.n3_6 = new boolean[]{true, true, false, false, false, false};
		this.n7_3 = new boolean[]{true, true, true};
		this.n0_3 = new boolean[]{false, false, false};
		this.n6_3 = new boolean[]{false, true, true};
		
		this.n17_5 = new boolean[]{true,  false, false, false, true};
		this.n15_5 = new boolean[]{true,  true,  true,  true,  true};
		this.n16_5  = new boolean[]{false, false, false, false, true};
	}

	@Test
	public void test1() {
		assertEquals(n3_4, this.adder.add(n1_4, n2_4));
		assertEquals(false, this.adder.getCarryBit());
	}
	
	@Test
	public void test2() {
		assertEquals(n2_4, this.adder.add(n1_4, n1_4));
		assertEquals(false, this.adder.getCarryBit());
	}
	
	@Test
	public void test3() {
		assertEquals(null, this.adder.add(n3_6, n3_4));
		assertEquals(false, this.adder.getCarryBit());
	}
	
	
	@Test
	public void test4() {
		assertEquals(n7_3, this.adder.add(n7_3, n0_3));
		assertEquals(false, this.adder.getCarryBit());
	}
	
	
	@Test
	public void test5() {
		assertEquals(n6_3, this.adder.add(n7_3, n7_3));
		assertEquals(true, this.adder.getCarryBit());
	}
	
	
	@Test
	public void test6() {
		assertEquals(n7_3, this.adder.add(n7_3, n0_3));
		assertEquals(false, this.adder.getCarryBit());
	}
	
	@Test
	public void test7() {
		assertEquals(n16_5, this.adder.add(n15_5, n17_5));
		assertEquals(true, this.adder.getCarryBit());
	}
	
	/*
	@Test
	public void testNEW() {
		boolean[] x = new boolean[]{false, true, false, false, true, true};
		boolean[] y = new boolean[]{true, true, false, false, true, true};
		boolean[] result = new boolean[]{true, false, true, false, false, true};
		
		assertEquals(result, this.adder.add(x, y));
		assertEquals(true, this.adder.getCarryBit());
	}
	*/
	
}
